<template>
  <div
    class="video-container height-width-100"
    :style="{ height: messageData?.dimension?.renderedHeight + 'px' }"
  >
    <video
      :style="{ height: messageData?.dimension?.renderedHeight + 'px' }"
      controls
      v-if="blobFilePath && !videoBlobPath"
    >
      <source :src="blobFilePath" />
    </video>
    <video
      :style="{ height: messageData?.dimension?.renderedHeight + 'px' }"
      controls
      v-if="videoBlobPath"
    >
      <source :src="blobFilePath" />
    </video>
    <IonIcon
      @click="emit('downloadMainMediaFile')"
      class="download-icon-file download-state-icon"
      icon="/Images/tabs/messages/download-file-icon.svg"
      color="white"
      v-if="blobFilePath && mainDownloadState == 'requestNotSent'"
    ></IonIcon>
    <IonIcon
      v-if="mainDownloadState == 'downloading'"
      class="download-icon-file downloading-state-icon"
      icon="/Images/tabs/messages/downloading-file-icon.svg"
      color="white"
    ></IonIcon>

    <TimeAndState
      class="state-chat-container-in-image"
      :date="messageData.date"
      :itsMe="messageData.itsMe"
      :status="messageData.status"
    ></TimeAndState>
  </div>
</template>
<script setup>
import { IonIcon } from '@ionic/vue';
import { defineProps, defineEmits, computed } from 'vue';
import TimeAndState from '@/components/message/basics/MessageCard/TimeAndState.vue';
import { useI18n } from 'vue-i18n';

const props = defineProps({
  messageData: {
    type: Object,
    default: () => {
      return {
        id: '',
        itsMe: false,
        date: '',
        status: 'sent',
        editedInfo: {
          isEdited: false,
          date: '',
        },
      };
    },
  },
  blobFilePath: {},
  videoBlobPath: {},
  mainDownloadState: {},
});
const emit = defineEmits(['downloadMainMediaFile']);
</script>
<style scoped>
video {
  width: 100%;
}
.video-container {
  position: relative;
  overflow: hidden;
  margin-bottom: 5px;
}

.video-item {
  width: 80vw;
  height: 80vw;
  opacity: 0;
  transition: 0.5s;
  object-fit: cover;
  display: block;
}
.video-item-show {
  opacity: 1;
}

.video-skelton-loading {
  background-color: var(--card-image-skleton-background);
  position: absolute;
  top: 0;
  left: 0;
}
.video-skelton-loading:after {
  content: '';
  height: 100%;
  width: 50%;
  position: absolute;
  top: 0;
  left: 0;
  transform: translate3d(-100%, 0, 0);
  background-color: var(--card-image-skleton-loader);
  animation-name: skleton-rolling;
  animation-fill-mode: both;
  animation-duration: 1.5s;
  animation-iteration-count: infinite;
  animation-timing-function: ease;
}
@keyframes skleton-rolling {
  0% {
    transform: translate3d(-100%, 0, 0);
  }
  100% {
    transform: translate3d(200%, 0, 0);
  }
}
.download-icon-file {
  position: absolute;
  left: 50%;
  top: 50%;
  width: 50px;
  height: 50px;
  transform: translate(-50%, -50%);
  background-color: var(--card-time-color-in-image);
  border-radius: 50%;
}
.download-state-icon {
  animation-name: scale-in;
  animation-duration: 0.5s;
  animation-timing-function: ease-in-out;
  animation-fill-mode: both;
  animation-iteration-count: 1;
}
@keyframes scale-in {
  0% {
    transform: translate(-50%, -50%) scale(1.5);
  }
  100% {
    transform: translate(-50%, -50%) scale(1);
  }
}
</style>
